/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2013-2014 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of the GNU General
 * Public License Version 2 only ("GPL"). You may not use this file except
 * in compliance with the License.  You can obtain a copy of the License at
 * https://avatar.java.net/license.html or legal/LICENSE.txt.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at legal/LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 */

var avatar = require("org/glassfish/avatar");

data = { transcript : "" };

avatar.registerSocketService({
    url: "websocket/chat"
},
function() {

    /**
     * Called when a new client connects.
     */
    this.onOpen = function(session) {
        avatar.log("onOpen called");
    };

    /**
     * Called when a client disconnects.
     */
    this.onClose = function(session) {
        avatar.log("onClose called");
    };

    /**
     * Called when a client disconnects.
     */
    this.onError = function(session, throwable) {
        avatar.log("onError called " + throwable);
    };

    /**
     * Called every time a new message is received.
     */
    this.onMessage = function(session, message) {
        avatar.log("onMessage called")
        data.transcript += message;
        data.transcript += "\n";

        var promise = session.getContext().sendAll(data);
        promise.then(function() {
            avatar.log("Message sent")
        }, function(err) {
            avatar.log("Error sending message");
        });
    };

});

var shutdownHook = function() {
    avatar.log("chat service is destroyed")
};

avatar.log("registering shutdown hook");
avatar.registerShutdownHook(shutdownHook);

