/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2013 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of the GNU General
 * Public License Version 2 only ("GPL"). You may not use this file except
 * in compliance with the License.  You can obtain a copy of the License at
 * https://avatar.java.net/license.html or legal/LICENSE.txt.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at legal/LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 */

var avatar = require("org/glassfish/avatar");

avatar.registerPushService({
    url: "push/stocks"
},
function() {

    this.data = {
        tickers: [ "ACME", "EACM", "MEAC", "CMEA" ],
        values: [ 25.0, 50.0, 75.0, 100.0 ]
    };

    this.onOpen = function(context) {
        avatar.logFine("onOpen called")
        context.setTimeout(1000);      // start timer
    };

    this.onClose = function(context) {
        avatar.logFine("onClose called");
    };

    this.onTimeout = function(context) {
        avatar.logFine("onTimeout called")
        this.updateData();

        var promise = context.sendMessage(this.data);
        promise.then(function() {
            avatar.logFine("Message sent (promise)");
        }, function(err) {
            avatar.log("Error sending message (promise): " + err);
        });

        context.setTimeout(1000);      // re-start timer
    };

    this.angle = 0;
    this.updateData = function() {
        for (var i in this.data.values) {
            this.angle += 0.1;
            var next = this.data.values[i] + Math.sin(this.angle) * 2;
            this.data.values[i] = Math.round(next * 100) / 100;     // two decimal places
        }
    };
});
