<?xml version="1.0" encoding="US-ASCII"?>
<!--

    DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.

    Copyright (c) 2013 Oracle and/or its affiliates. All rights reserved.

    The contents of this file are subject to the terms of the GNU General
    Public License Version 2 only ("GPL"). You may not use this file except
    in compliance with the License.  You can obtain a copy of the License at
    https://avatar.java.net/license.html or legal/LICENSE.txt.  See the
    License for the specific language governing permissions and limitations
    under the License.

    When distributing the software, include this License Header Notice in each
    file and include the License file at legal/LICENSE.txt.

    GPL Classpath Exception:
    Oracle designates this particular file as subject to the "Classpath"
    exception as provided by Oracle in the GPL Version 2 section of the License
    file that accompanied this code.

    Modifications:
    If applicable, add the following below the License Header, with the fields
    enclosed by brackets [] replaced by your own identifying information:
    "Portions Copyright [year] [name of copyright owner]"

-->

<!--
  - Generator for Reference Documentation
  - @author spericas@java.net
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns:a="http://www.glassfish.org/avatar"
                xmlns:util="http://xml.apache.org/xalan/java/org.glassfish.avatar.util.GenReferenceDocUtil"
                exclude-result-prefixes="xsl util a">

    <xsl:param name="widgetLib" select="'jquery'"/>
    
    <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>

    <xsl:template match="/">
        <xsl:if test="not(a:viewModule[@ifOption]) and $widgetLib = 'jquery'">
            <xsl:call-template name="generateDoc"/>
        </xsl:if>
        <xsl:if test='util:contains(a:viewModule/@ifOption, concat("&apos;", concat($widgetLib, "&apos;")))'>
            <xsl:call-template name="generateDoc"/>
        </xsl:if>
    </xsl:template>

    <xsl:template name="generateDoc">
        <dl>
            <xsl:apply-templates/>
        </dl>
    </xsl:template>

    <xsl:template match="a:definition">
        <!-- Ignore internal HTML widgets -->
        <xsl:if test="not(util:startsWith(@id, 'html') or util:startsWith(@id, '$'))">
            <li>
                <a href="#{@id}">
                    <xsl:value-of select="@id"/>
                </a>
            </li>
        </xsl:if>
    </xsl:template>

    <xsl:template match="comment()">
        <!-- no-op -->
    </xsl:template>

    <!--
    - Ignore arbitrary text nodes.
    -->
    <xsl:template match="text()">
        <!-- no-op -->
    </xsl:template>

</xsl:stylesheet>
